//Arduino Uno 433 MHZ RF transmitter code

#include <VirtualWire.h>

const int transmit_pin = 11;
const int receive_pin = 12;
const int transmit_en_pin = 3;
const int led_pin = 13;
const int lm35Pin = A0; //temperature sensor connected to analog pin A0

struct package
{
  float temperatureC ;
  float temperatureF ;
};
typedef struct package Package;
Package data;

void setup()
{
  Serial.begin(9600);
  // Initialise the IO and ISR
  vw_set_tx_pin(transmit_pin);
  vw_set_rx_pin(receive_pin);
  vw_set_ptt_pin(transmit_en_pin);
  vw_set_ptt_inverted(true); // Required for DR3100
  vw_setup(500);       // Bits per sec
  pinMode(led_pin, OUTPUT);
}

void loop()
{
  digitalWrite(led_pin, HIGH); // Flash a light to show transmitting
  readSensor();
  vw_send((uint8_t *)&data, sizeof(data));
  vw_wait_tx(); // Wait until the whole message is gone
  digitalWrite(led_pin, LOW);
  delay(2000);
}
void readSensor()
{
  int tempsensor = analogRead(lm35Pin);
  float value = ( tempsensor / 1023.0) * 5000;
  float celsius = value / 10;
  float fahrenheit = (celsius * 9) / 5 + 32;
  data.temperatureC = celsius;
  data.temperatureF = fahrenheit;
  Serial.print("Temperature = ");
  Serial.print(celsius);
  Serial.print("*C ");
  Serial.print("Temperature = ");
  Serial.print(fahrenheit);
  Serial.print("*F ");
  Serial.println();
}
